#!/bin/env bash

set -e

. /etc/profile

COREMEDIA_BUILD_DIR={{ coremedia_build_tmp_directory }}

DISABLE_EXTENSION_ELASTIC_SOCIAL={{ coremedia_build_disable_extension.elastic_social | bool | ternary('true','false') }}
DISABLE_EXTENSION_ADAPTIVE_PERSONALIZATION={{ coremedia_build_disable_extension.adaptive_personalization | bool | ternary('true','false') }}
DISABLE_EXTENSION_ECOMMERCE={{ coremedia_build_disable_extension.ecommerce | bool | ternary('true','false') }}
DISABLE_EXTENSION_ADVANCED_ASSET_MANAGEMENT={{ coremedia_build_disable_extension.advanced_asset_management | bool | ternary('true','false') }}

REMOVE_DOCKER_IMAGES={{ coremedia_build_force | bool | ternary('true','false') }}

{%- if coremedia_build_force %}
{# update all snapshots #}
{{ coremedia_build_opts.append('--update-snapshots') or "" }}
{% endif %}
{# create docker container for deployment #}
{%- if coremedia_build_docker %}
{{ coremedia_build_opts.append('--activate-profiles with-docker') or "" }}
{% else %}
{# disable registry settings #}
{{ coremedia_build_opts.append('--define dockerfile.googleContainerRegistryEnabled=false') or "" }}
{% endif %}
{# create deployment archive for chef deployment #}
{%- if coremedia_build_chef %}
{{ coremedia_build_opts.append('--activate-profiles with-chef') or "" }}
{% endif %}
{%- if coremedia_build_use_image_tag is defined and coremedia_build_use_image_tag != 'latest' %}
{{ coremedia_build_opts.append(["--define docker.image.tag", coremedia_build_use_image_tag] | join('=') ) or "" }}
{% endif %}
{%- if coremedia_build_use_repository_prefix is defined and coremedia_build_use_repository_prefix | length != 0 %}
{{ coremedia_build_opts.append(["--define docker.repository.prefix", coremedia_build_use_repository_prefix] | join('=') ) or "" }}
{% endif %}
{# define custom docker repository for application-base-image #}
{%- if coremedia_build_use_docker_base_image is defined and
  coremedia_build_use_docker_base_image.repo is defined and
  coremedia_build_use_docker_base_image.repo | length != 0 %}
{{ coremedia_build_opts.append(["--define docker.java-application-base-image.repo", coremedia_build_use_docker_base_image.repo] | join('=') ) or "" }}
{% endif %}
{# define custom docker tag for application-base-image #}
{%- if coremedia_build_use_docker_base_image is defined and
  coremedia_build_use_docker_base_image.tag is defined and
  coremedia_build_use_docker_base_image.tag | length != 0 %}
{{ coremedia_build_opts.append(["--define docker.java-application-base-image.tag", coremedia_build_use_docker_base_image.tag] | join('=') ) or "" }}
{% endif %}

# -------------------------------------------------------------------------------------------------

build_base_image() {
  echo "build own base image"
}

clean_docker_images() {

  if [ "${REMOVE_DOCKER_IMAGES}" = "true" ]
  then
    echo "clean docker images"
    set +e
    docker rmi --force $(docker images --quiet --all) > /dev/null 2>&1
    set -e
  fi
}

remove_extensions() {

  if [ -d ${COREMEDIA_BUILD_DIR}/workspace/workspace-configuration/extensions ]
  then
    echo "remove extensions"

    # https://documentation.coremedia.com/cmcc-10/artifacts/2007/webhelp/coremedia-en/content/DevelopmentWithExtensions.html
    pushd "${COREMEDIA_BUILD_DIR}/workspace/workspace-configuration/extensions" > /dev/null

    # https://documentation.coremedia.com/cmcc-10/artifacts/2007/webhelp/coremedia-en/content/removeElastic.html
    if [ "${DISABLE_EXTENSION_ELASTIC_SOCIAL}" = "true" ]
    then
      echo "  - Elastic Social Extension"

      mvn extensions:sync -Ddisable=es,es-p13n,es-alx,lc-es,sfmc-es-p13n
    fi

    if [ "${DISABLE_EXTENSION_ELASTIC_SOCIAL}" = "true" ]
    then
      echo "  - Adaptive Personalization Extension"
      # https://documentation.coremedia.com/cmcc-10/artifacts/2007/webhelp/coremedia-en/content/removeAPI.html
      mvn extensions:sync -Ddisable=p13n,alx-p13n,es-p13n,lc-p13n,sfmc-p13n,sfmc-es-p13n
    fi

    if [ "${DISABLE_EXTENSION_ELASTIC_SOCIAL}" = "true" ]
    then
      echo "  - eCommerce Blueprint"
      # https://documentation.coremedia.com/cmcc-10/artifacts/2007/webhelp/coremedia-en/content/removeLc.html
      mvn extensions:sync -Ddisable=lc,lc-asset,lc-es,lc-p13n,ecommerce-ibm,hybris,ecommerce-sfcc,ecommerce-adapter
    fi

    if [ "${DISABLE_EXTENSION_ELASTIC_SOCIAL}" = "true" ]
    then
      echo "  - Advanced Asset Management Extensions"
      # https://documentation.coremedia.com/cmcc-10/artifacts/2007/webhelp/coremedia-en/content/removeLcAssetManagement.html
      mvn extensions:sync -Ddisable=lc-asset,am
    fi

    popd > /dev/null

  fi
}

build_artefacts() {

  if [ -d ${COREMEDIA_BUILD_DIR}/workspace ]
  then
    pushd ${COREMEDIA_BUILD_DIR}/workspace > /dev/null

    # mvn dependency:go-offline
    mvn clean install \
      {{ coremedia_build_opts | sort | join(' ') }}

    popd > /dev/null
  fi
}

build_cm_docker() {

  if [ -d ${COREMEDIA_BUILD_DIR}/workspace ]
  then
    pushd ${COREMEDIA_BUILD_DIR}/workspace > /dev/null

    if [ -d global/deployment/docker ]
    then
      pushd global/deployment/docker/  > /dev/null

      for container in traefik overview mongodb
      do
        if [ -d ./${container} ]
        then
          pushd "${container}"  > /dev/null
          [ -f Dockerfile ] && docker build --tag ${container}:latest .

          popd  > /dev/null
        fi
      done
    fi

    popd  > /dev/null
  fi
}

# ulimit -n 50000

# mvn clean

run() {

  # pushd ${COREMEDIA_BUILD_DIR} > /dev/null
  # build_base_image

  clean_docker_images

  remove_extensions

  build_artefacts

  build_cm_docker
}

run

